var preloadState = {
  preload: function() {
    game.load.image("storeBackground", "assets/RS-Background.png");
    game.load.image("workshopBackground", "assets/Taller-Background.png");
    game.load.image("workbenchBackground", "assets/workbench.png");

    game.load.image("door", "assets/Door.png");
    game.load.image("backToWorkshop", "assets/UI/Button/backToWorkshop.png");
    game.load.image("table", "assets/mesa-taller.png");
    game.load.image("shelf", "assets/estanteria.png");
    game.load.image("dialogBackground", "assets/DialogBackground.png");
    game.load.image("buttonAccept", "assets/ButtonAccept.png");
    game.load.image("buttonRefuse", "assets/ButtonRefuse.png");
    game.load.image("newClientRingBubble", "assets/CampanaNuevoCliente.png");
    game.load.image("item-oso", "assets/items/Oso.png");
    game.load.image("statusFrame", "assets/UI/status.png");
    game.load.image("speechBubble", "assets/speechBubble.png");
    game.load.image("parcel", "assets/parcel.png");
    game.load.image("parcelIcon", "assets/parcel-icon.png");
    game.load.spritesheet("player", "assets/maincharacter.png", 48, 48);

    game.load.image("clock","assets/UI/clock.png")
    game.load.image("arrow","assets/UI/arrow.png")

    // Audio
    game.load.audio('theme', 'https://raw.githubusercontent.com/lunafromthemoon/GGJ2020/master/assets/temaGGJ.mp3?token=ABS6OIVDN45JCVKOJSPRVTS6GYHJE');

    // toys
    for (var i = toys.length - 1; i >= 0; i--) {
        game.load.image(toys[i], "assets/items/"+toys[i]+".png");
        game.load.image(toys[i]+"Icon", "assets/items/"+toys[i]+"-icon.png");
    };
    
    // tools
    game.load.image("eyesButton","assets/UI/Button/eyes.png")
    game.load.image("earsButton","assets/UI/Button/ears.png")
    game.load.image("needleButton","assets/UI/Button/needle.png")
    game.load.image("patchesButton","assets/UI/Button/patches.png")
    game.load.image("bowsButton","assets/UI/Button/bows.png")

    game.load.image("toolbox","assets/UI/Button/toolbox.png")
    game.load.image("toolboxHandle","assets/UI/Button/toolbox-handle.png")
    for (var tool in inventory){
        for (var i = 0; i < inventory[tool].length; i++) {
            inventory[i]
            game.load.image(tool+inventory[tool][i],"assets/UI/Button/"+tool+"/"+inventory[tool][i]+".png")
        };
    }
    
  },
  create: function() {
    let theme = game.add.audio("theme");
    game.sound.setDecodedCallback(theme, () => {
      theme.loopFull(0.4);
      game.state.start("workshop");
    }, this);
  }
};

var toys = ["bear","tigre","rabbit"]

var inventory = {
    eyes: ["black","cat-red","cat-yellow","cyan","green","purple"],
    needle: [],
    ears: [],
    patches: ["blue","brown","orange","red","yellow"],
    bows: ["blue-hearts","blue","cyan","green","green-hearts","green-waves","orange","orange-hearts","pink","pink-starts","purple","red"]
}

function setStatusFrame(x, y) {
  let statusFrame = game.add.sprite(x, y, "statusFrame");
  statusFrame.x = x;
  statusFrame.y = y;

  var style = {
    font: "18px Arial",
    fontWeight: "bold",
    fill: "#000",
    align: "left", // the alignment of the text is independent of the bounds, try changing to 'center' or 'right'
    boundsAlignH: "left",
    boundsAlignV: "top",
    wordWrap: true,
    wordWrapWidth: 300
  };
  globalState.moneyText = game.add.text(63, 55, `\$ ${globalState.money}`, style);
  statusFrame.addChild(globalState.moneyText);

  var clock = game.add.sprite(700,50,'clock');
  clock.anchor.set(0.5);
  var arrow = game.add.sprite(0,0,"arrow");
  arrow.anchor.set(0.5);
  clock.addChild(arrow);
  arrow.angle =  (globalState.clock) ? globalState.clock.angle : globalState.time;
  globalState.clock = arrow;
  var nextAngle = (globalState.daytime == "morning") ? 180 : 360;
  var tween = game.add.tween(arrow).to({angle:nextAngle},60000)
  tween.onComplete.addOnce(function(){
    console.log("Finish day")
  },this);
  tween.start();
}

function createPlayer(x, y, frame) {
  var player = game.add.sprite(x, y, "player", frame);
  player.anchor.set(0.5);
  player.animations.add("walk-down", [0, 4, 8, 12]);
  player.animations.add("walk-left", [1, 5, 9, 13]);
  player.animations.add("walk-up", [2, 6, 10, 14]);
  player.animations.add("walk-right", [3, 7, 11, 15]);
  return player;
}

var globalState = {
  works: [null, null, null, null, null, null],
  clients: [true],
  lastRoom: null,
  money: 500,
  time:0,
  daytime: "morning",
  waiting: [null,null,null],
  userInventory: {
        eyes: ["black","cat-red","green","green","purple"],
        needle: [],
        ears: [],
        patches: ["brown","blue","red"],
        bows: ["pink","red","purple"]
    }
};

function nextFreeSpace(list){
    for (var i = 0; i < list.length; i++) {
        if (!list[i]) return i;
    };
    return -1;
}

var stageSize = { w: 800, h: 600 };
var game = new Phaser.Game(stageSize.w, stageSize.h, Phaser.CANVAS, "game");

game.state.add("preload", preloadState);
game.state.add("workshop", workshopState);
game.state.add("workbench", workbenchState);
game.state.add("store", storeState);
game.state.start("preload");
