var storeState = {
  create: function() {
    game.add.sprite(0, 0, "storeBackground");
    var door = game.add.sprite(0, 450, "door");
    door.inputEnabled = true;
    door.events.onInputDown.add(function() {
      leaveStore(player);
    }, this);
    setStatusFrame(554, 21);
    newClient((item,client) => {
      openDialog("test", item,client);
    });
    if (!globalState.lastRoom) {
      player = createPlayer(125, 500, 3);
    } else {
      player = createPlayer(-20, 500, 3);
      enterStore(player);
    }
    globalState.lastRoom = "store";
  },
  update: function() {},
  render: function() {}
};

function enterStore(player) {
  player.walking = true;
  player.animations.play("walk-right", 12, true);
  player.tween = game.add.tween(player);
  player.tween.to({ x: 125 }, 1000, Phaser.Easing.Linear.None);
  player.tween.onComplete.addOnce(function() {
    player.animations.stop();
    player.walking = false;
  }, this);
  player.tween.start();
}

function leaveStore(player) {
  if (player.walking) return;
  player.animations.play("walk-left", 12, true);
  player.tween = game.add.tween(player);
  player.tween.to({ x: -25 }, 1000, Phaser.Easing.Linear.None);
  player.tween.onComplete.addOnce(function() {
    game.state.start("workshop");
  }, this);
  player.tween.start();
}

function onClickAccept(name, item) {
    var index = nextFreeSpace(globalState.works);
    globalState.works[index] = {toy:item};
}

function onClickRefuse(name, item) {}

function openDialog(name, item,client) {
  var dialogGroup = game.add.group();
  let dialog = dialogGroup.create(473, 124, "dialogBackground");
  dialog.inputEnabled = true;
  let buttonAccept = dialogGroup.create(490, 498, "buttonAccept");
  buttonAccept.inputEnabled = true;
  buttonAccept.input.useHandCursor = true;
  buttonAccept.events.onInputDown.addOnce(function() {
    dialogGroup.destroy();
    onClickAccept(name, item);
    clientLeaves(client)
  });
  let buttonRefuse = dialogGroup.create(683, 498, "buttonRefuse");
  buttonRefuse.inputEnabled = true;
  buttonRefuse.input.useHandCursor = true;
  buttonRefuse.events.onInputDown.addOnce(function() {
    dialogGroup.destroy();
    onClickRefuse(name, item);
    clientLeaves(client)
  });

  var style = {
    font: "22px Arial",
    fontWeight: "bold",
    fill: "#000",
    align: "left", // the alignment of the text is independent of the bounds, try changing to 'center' or 'right'
    boundsAlignH: "left",
    boundsAlignV: "top",
    wordWrap: true,
    wordWrapWidth: 300
  };

  text = game.add.text(492, 152, `${name} wants to repair ${item}`, style);

  text.setTextBounds(0, 0, 275, 78);
  dialogGroup.add(text)
}

function clientLeaves(client){
    var tween = game.add.tween(client).to({ y:"+50" }, 500);
    tween.onComplete.addOnce(function() {
        client.animations.play("walk-right", 12, true);
        tween = game.add.tween(client).to({ x:800 }, 1500).start();
        tween.onComplete.addOnce(function() {
            client.destroy();
        })
    })
    client.animations.play("walk-down", 12, true);
    tween.start();
}

function newClient(callback) {
  let client = game.add.sprite(800, 500, "player");
  client.anchor.set(0.5);
  client.animations.add("walk-down", [0, 4, 8, 12]);
  client.animations.add("walk-left", [1, 5, 9, 13]);
  client.animations.add("walk-up", [2, 6, 10, 14]);
  client.animations.add("walk-right", [3, 7, 11, 15]);
  client.animations.play("walk-left", 12, true);
  client.tween = game.add.tween(client);
  client.tween.to({ x: 300 }, 1500, Phaser.Easing.Linear.None);
  client.tween.onComplete.addOnce(function() {
    client.animations.stop();
    client.inputEnabled = true;
    client.input.useHandCursor = true;

    let item = game.rnd.pick(toys);
    var bubble = null;
    client.events.onInputDown.addOnce(function(sprite) {
      callback(item,client);
    });
    client.events.onInputOver.add(function() {
      bubble = game.add.sprite(3, -75, "speechBubble");
      bubble.addChild(game.add.sprite(15, 6, item+"Icon"));
      client.addChild(bubble);
    });
    client.events.onInputOut.add(function() {
      if (bubble) {
        bubble.kill();
        bubble = null;
      }
    });
  }, this);
  client.tween.start();
}
